export declare type AsyncState<T> = {
    loading: boolean;
    error?: undefined;
    value?: undefined;
} | {
    loading: false;
    error: Error;
    value?: undefined;
} | {
    loading: false;
    error?: undefined;
    value: T;
};
declare const useAsyncFn: <T>(fn: () => Promise<T>, deps?: readonly any[]) => [AsyncState<T>, () => void];
export default useAsyncFn;
